package org.yaoqiang.bpmn.editor.swing;

import org.yaoqiang.bpmn.editor.action.BPMNModelActions;
import org.yaoqiang.graph.action.GraphActions;
import org.yaoqiang.graph.editor.swing.BaseEditor;
import org.yaoqiang.graph.editor.swing.MainToolBar;

import com.mxgraph.util.mxResources;

/**
 * BPMNToolBar
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class BPMNToolBar extends MainToolBar {

	private static final long serialVersionUID = 1L;

	public BPMNToolBar(BaseEditor editor, int orientation) {
		super(editor, orientation);
	}

	protected void populateFileToolbar(BaseEditor editor) {
		add(editor.bind(mxResources.get("new"), BPMNModelActions.getAction(BPMNModelActions.NEW), "/org/yaoqiang/graph/editor/images/new.png"));
		add(editor.bind(mxResources.get("OpenFile"), BPMNModelActions.getAction(BPMNModelActions.OPEN), "/org/yaoqiang/graph/editor/images/open.png"));
		add(editor.bind(mxResources.get("OpenURL"), BPMNModelActions.getAction(BPMNModelActions.OPEN_URL), "/org/yaoqiang/bpmn/editor/images/openurl.png"));
		add(editor.bind(mxResources.get("reload"), BPMNModelActions.getAction(BPMNModelActions.RELOAD), "/org/yaoqiang/graph/editor/images/reload.png"));
		add(editor.bind(mxResources.get("save"), BPMNModelActions.getSaveAction(), "/org/yaoqiang/graph/editor/images/save.png"));
		add(editor.bind(mxResources.get("saveAs"), BPMNModelActions.getSaveAsAction(), "/org/yaoqiang/graph/editor/images/save_as.png"));
		add(editor.bind(mxResources.get("saveAsPNG"), BPMNModelActions.getSaveAsPNG(), "/org/yaoqiang/graph/editor/images/png.png"));
		add(editor.bind(mxResources.get("saveAsODT"), BPMNModelActions.getSaveAsODT(), "/org/yaoqiang/bpmn/editor/images/odt.png"));

		addSeparator();

		add(editor.bind(mxResources.get("pageSetup"), GraphActions.getAction(GraphActions.PAGE_SETUP), "/org/yaoqiang/graph/editor/images/page_setup.png"));
		add(editor.bind(mxResources.get("print"), GraphActions.getAction(GraphActions.PRINT), "/org/yaoqiang/graph/editor/images/printer.png"));

		addSeparator();

		add(editor.bind(mxResources.get("SaveToNativeRepo"), BPMNModelActions.getAction(BPMNModelActions.SAVE_TO_REPO), "/org/yaoqiang/bpmn/editor/images/save_to_repo.png"));
		add(editor.bind(mxResources.get("VersionHistory"), BPMNModelActions.getAction(BPMNModelActions.VERSION_HISTORY), "/org/yaoqiang/bpmn/editor/images/version_history.png"));
		add(editor.bind(mxResources.get("DeployProcessDefinition"), BPMNModelActions.getAction(BPMNModelActions.DEPLOY),
				"/org/yaoqiang/bpmn/editor/images/deploy.png"));

		addSeparator();

		add(editor.bind(mxResources.get("run"), BPMNModelActions.getAction(BPMNModelActions.RUN_SIMULATION), "/org/yaoqiang/bpmn/editor/images/run.png"));
		add(editor.bind(mxResources.get("pause"), BPMNModelActions.getAction(BPMNModelActions.PAUSE_SIMULATION), "/org/yaoqiang/bpmn/editor/images/pause.png"));
		add(editor.bind(mxResources.get("stop"), BPMNModelActions.getAction(BPMNModelActions.STOP_SIMULATION), "/org/yaoqiang/bpmn/editor/images/stop.png"));
	}

	protected void populateGridToolbar(BaseEditor editor) {
		add(editor.bind(mxResources.get("grid"), BPMNModelActions.getAction(BPMNModelActions.GRID), "/org/yaoqiang/graph/editor/images/grid.png"));
	}
}
